## maas 1.3+bzr1461+dfsg

=== Makefile ===
python := python2.7

# Network activity can be suppressed by setting offline=true (or any
# non-empty string) at the command-line.
ifeq ($(offline),)
buildout := bin/buildout
virtualenv := virtualenv
else
buildout := bin/buildout buildout:offline=true
virtualenv := virtualenv --never-download
endif

# If offline has been selected, attempt to further block HTTP/HTTPS
# activity by setting bogus proxies in the environment.
ifneq ($(offline),)
export http_proxy := broken
export https_proxy := broken
endif

# Python enum modules.
py_enums := $(wildcard src/*/enum.py)
# JavaScript enum module (not modules).
js_enums := src/maasserver/static/js/enums.js

# Prefix commands with this when they need access to the database.
# Remember to add a dependency on bin/database from the targets in
# which those commands appear.
dbrun := bin/database --preserve run --

# For things that care, postgresfixture for example, we always want to
# use the "maas" databases.
export PGDATABASE := maas

build: \
    bin/buildout \
    bin/database \
    bin/maas bin/test.maas \
    bin/maascli bin/test.maascli \
    bin/test.maastesting \
    bin/twistd.pserv bin/test.pserv \
    bin/twistd.txlongpoll \
    bin/py bin/ipy \
    $(js_enums)

all: build doc

# Install all packages required for MAAS development & operation on
# the system. This may prompt for a password.
install-dependencies:
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
		--no-install-recommends install \
		$(shell sort -u required-packages/base required-packages/dev)

bin/python bin/pip:
	$(virtualenv) --python=$(python) --system-site-packages $(CURDIR)

bin/buildout: bin/pip bootstrap/zc.buildout-1.5.2.tar.gz
	bin/pip --quiet install --ignore-installed \
	    --no-dependencies bootstrap/zc.buildout-1.5.2.tar.gz
	$(RM) -f README.txt  # zc.buildout installs an annoying README.txt.
	@touch --no-create $@  # Ensure it's newer than its dependencies.

bin/database: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install database
	@touch --no-create $@

bin/maas: bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install maas
	@touch --no-create $@

bin/test.maas: bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install maas-test
	@touch --no-create $@

bin/maascli: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install maascli
	@touch --no-create $@

bin/test.maascli: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install maascli-test
	@touch --no-create $@

bin/test.maastesting: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install maastesting-test
	@touch --no-create $@

bin/celeryd bin/maas-provision bin/twistd.pserv: \
    bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install pserv
	@touch --no-create $@

bin/test.pserv: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install pserv-test
	@touch --no-create $@

bin/twistd.txlongpoll: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install txlongpoll
	@touch --no-create $@

bin/flake8: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install flake8
	@touch --no-create $@

bin/sphinx bin/sphinx-build: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install sphinx
	@touch --no-create $@

bin/py bin/ipy: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install repl
	@touch --no-create bin/py bin/ipy

test: build
	echo $(wildcard bin/test.*) | xargs -n1 env

lint: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities
lint: bin/flake8
	@find $(sources) -name '*.py' ! -path '*/migrations/*' \
	    -print0 | xargs -r0 bin/flake8

pocketlint = $(call available,pocketlint,python-pocket-lint)

lint-css: sources = src/maasserver/static/css
lint-css:
	@find $(sources) -type f \
	    -print0 | xargs -r0 $(pocketlint) --max-length=120

lint-js: sources = src/maasserver/static/js
lint-js:
	@find $(sources) -type f -print0 | xargs -r0 $(pocketlint)

check: clean test

docs/api.rst: bin/maas src/maasserver/api.py syncdb
	bin/maas generate_api_doc > $@

sampledata: bin/maas bin/database syncdb
	$(dbrun) bin/maas loaddata src/maasserver/fixtures/dev_fixture.yaml

doc: bin/sphinx docs/api.rst
	bin/sphinx

man: $(patsubst docs/man/%.rst,man/%,$(wildcard docs/man/*.rst))

man/%: docs/man/%.rst | bin/sphinx-build
	bin/sphinx-build -b man docs man $^

enums: $(js_enums)

$(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
	 bin/py -m src/maasserver/utils/jsenums $(py_enums) > $@

clean:
	$(MAKE) -C acceptance $@
	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
	find . -type f -name dropin.cache -print0 | xargs -r0 $(RM)
	$(RM) -r media/demo/* media/development
	$(RM) $(js_enums)
	$(RM) *.log
	$(RM) docs/api.rst
	$(RM) -r docs/_autosummary docs/_build
	$(RM) -r man/.doctrees

distclean: clean stop
	$(RM) -r bin include lib local
	$(RM) -r eggs develop-eggs
	$(RM) -r build dist logs/* parts
	$(RM) tags TAGS .installed.cfg
	$(RM) -r *.egg *.egg-info src/*.egg-info
	$(RM) -r run/* services/*/supervise

harness: bin/maas bin/database
	$(dbrun) bin/maas shell --settings=maas.demo

dbharness: bin/database
	bin/database --preserve shell

syncdb: bin/maas bin/database
	$(dbrun) bin/maas syncdb --noinput
	$(dbrun) bin/maas migrate maasserver --noinput
	$(dbrun) bin/maas migrate metadataserver --noinput

define phony_targets
  build
  check
  clean
  dbharness
  distclean
  doc
  enums
  harness
  install-dependencies
  lint
  lint-css
  lint-js
  man
  sampledata
  syncdb
  test
endef

#
# Development services.
#

service_names_region := database dns region-worker reloader txlongpoll web webapp
service_names_cluster := cluster-worker pserv reloader
service_names_all := $(service_names_region) $(service_names_cluster)

# The following template is intended to be used with `call`, and it
# accepts a single argument: a target name. The target name must
# correspond to a service action (see "Pseudo-magic targets" below).
# A region- and cluster-specific variant of the target will be
# created, in addition to the target itself. These can be used to
# apply the service action to the region services, the cluster
# services, or all services, at the same time.
define service_template
$(1)-region: $(patsubst %,services/%/@$(1),$(service_names_region))
$(1)-cluster: $(patsubst %,services/%/@$(1),$(service_names_cluster))
$(1): $(1)-region $(1)-cluster
phony_services_targets += $(1)-region $(1)-cluster $(1)
endef

# Expand out aggregate service targets using `service_template`.
$(eval $(call service_template,pause))
$(eval $(call service_template,restart))
$(eval $(call service_template,start))
$(eval $(call service_template,status))
$(eval $(call service_template,stop))
$(eval $(call service_template,supervise))

# The `run` targets do not fit into the mould of the others.
run-region:
	@services/run $(service_names_region)
run-cluster:
	@services/run $(service_names_cluster)
run:
	@services/run $(service_names_all)

phony_services_targets += run-region run-cluster run

# This one's for the rapper, yo.
run+webapp:
	@services/run $(service_names_region) +webapp

phony_services_targets += run+webapp

# Convenient variables and functions for service control.

setlock = $(call available,setlock,daemontools)
supervise = $(call available,supervise,daemontools)
svc = $(call available,svc,daemontools)
svok = $(call available,svok,daemontools)
svstat = $(call available,svstat,daemontools)

service_lock = $(setlock) -n /run/lock/maas.dev.$(firstword $(1))

# Pseudo-magic targets for controlling individual services.

services/%/@run: services/%/@stop services/%/@deps
	@$(call service_lock, $*) services/$*/run

services/%/@start: services/%/@supervise
	@$(svc) -u $(@D)

services/%/@pause: services/%/@supervise
	@$(svc) -d $(@D)

services/%/@status:
	@$(svstat) $(@D)

services/%/@restart: services/%/@supervise
	@$(svc) -du $(@D)

services/%/@stop:
	@if $(svok) $(@D); then $(svc) -dx $(@D); fi
	@while $(svok) $(@D); do sleep 0.1; done

services/%/@supervise: services/%/@deps
	@mkdir -p logs/$*
	@touch $(@D)/down
	@if ! $(svok) $(@D); then \
	    logdir=$(CURDIR)/logs/$* \
	        $(call service_lock, $*) $(supervise) $(@D) & fi
	@while ! $(svok) $(@D); do sleep 0.1; done

# Dependencies for individual services.

services/dns/@deps: bin/py

services/cluster-worker/@deps: bin/celeryd

services/region-worker/@deps: bin/celeryd

services/database/@deps: bin/database

services/pserv/@deps: bin/twistd.pserv

services/reloader/@deps:

services/txlongpoll/@deps: bin/twistd.txlongpoll

services/web/@deps:

services/webapp/@deps: bin/maas

#
# Phony stuff.
#

define phony
  $(phony_services_targets)
  $(phony_targets)
endef

phony := $(sort $(strip $(phony)))

.PHONY: $(phony)

#
# Functions.
#

# Check if a command is found on PATH. Raise an error if not, citing
# the package to install. Return the command otherwise.
# Usage: $(call available,<command>,<package>)
define available
  $(if $(shell which $(1)),$(1),$(error $(1) not found; \
    install it with 'sudo apt-get install $(2)'))
endef

=== acceptance/Makefile ===
#
# Build and test everything in ephemeral containers:
#
#   $ make
#
# Use a different packaging branch:
#
#   $ make packaging=/path/to/branch
#
# Note: /path/to/branch can be anything that bzr recognises, so an lp:
# link, or bzr+ssh, and so on.
#
# Build and test with a different Ubuntu series:
#
#   $ make series=randy
#

include /etc/lsb-release

# Default to the newer of Quantal or the local series.
series := $(lastword $(sort quantal $(DISTRIB_CODENAME)))

# Default to the main packaging branch on Launchpad, but treat Precise
# specially.
ifeq ($(series),precise)
packaging := lp:~maas-maintainers/maas/packaging.precise
else
packaging := lp:~maas-maintainers/maas/packaging
endif

# Assume we're testing this branch.
upstream := $(abspath ..)

# The container on which to base ephemerals.
container := maas-$(series)
containerdir := /var/lib/lxc/$(container)

## Convenience definitions.

define ephexec
sudo LC_ALL=C SSH_ASKPASS=$(abspath ubuntupass) setsid \
    lxc-start-ephemeral -b $(abspath .) -o $(container) -u ubuntu -- \
    DEBIAN_FRONTEND=noninteractive SUDO_ASKPASS=$(abspath ubuntupass)
endef

define ephexec-make
$(ephexec) $(abspath with-make) make -C $(abspath .)
endef

define check-service
test $(2) = $(wordlist 2,2,$(shell service $(1) status))  # $(1)
endef

## Top-level targets.

test: build | services sudo container
	$(ephexec-make) $@-inner

# lxc-start-ephemeral does not return the exit code of any command it
# runs, so we delete any existing packages before building and check
# for their presence afterwards instead.
build: source source/debian | services sudo container
	@$(RM) *.deb
	$(ephexec-make) $@-inner
	@ls -1 *.deb
	@touch $@

container: $(containerdir)

services:
	$(call check-service,lxc,start/running)
	$(call check-service,lxc-net,start/running)

define phony-outer-targets
  container
  services
  test
endef

## Targets that run within an LXC container.

# XXX: These packages appear to be missing from the dependencies
# declared in the packaging branch.
define missing-packages
  python-distribute
  python-django
endef

test-inner: upgrade-inner
	sudo -AE apt-get --assume-yes install $(strip $(missing-packages))
	sudo -AE dpkg --unpack --force-depends -- *.deb
	sudo -AE apt-get --fix-broken --assume-yes install

define build-packages
  debhelper
  devscripts
  dh-apport
endef

build-inner: upgrade-inner
	sudo -AE apt-get --assume-yes install $(strip $(missing-packages))
	sudo -AE apt-get --assume-yes install $(strip $(build-packages))
	cd source && debuild -i -us -uc -b

upgrade-inner:
	sudo -AE apt-get --assume-yes update
	sudo -AE apt-get --assume-yes upgrade

define phony-inner-targets
  build-inner
  test-inner
  upgrade-inner
endef

## Dependencies.

source:
	bzr export --uncommitted $@ $(upstream)

source/debian: | source
	bzr export $@ $(packaging)/debian

$(containerdir): | sudo
	sudo lxc-create -n $(container) \
	    -t ubuntu -- --release $(series)

## Miscellaneous.

sudo:
	@sudo -v

clean:
	$(RM) -r source build *.build *.changes *.deb

define phony-misc-targets
  clean
  sudo
endef

## Phony.

define phony
  $(phony-inner-targets)
  $(phony-misc-targets)
  $(phony-outer-targets)
endef

phony := $(sort $(strip $(phony)))

.PHONY: $(phony)

=== debian/changelog ===
maas (1.3+bzr1461+dfsg-0ubuntu2) raring; urgency=low

  * debian/patches/99-fix-maas-fpi.patch: Update to correctly reflect
    correct install path.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 19 Apr 2013 09:41:18 -0700

maas (1.3+bzr1461+dfsg-0ubuntu1) raring; urgency=low

  * This is a new upstream bugfixs releases only. It includes:
    - Fix detection of non-existant ipmi device in nested kvm (LP: #1064527)
    - Fix IPMI User creation. (LP: #1119696)
    - Assign nodes to the correct nodegroup. (LP: #1148016)
    - Fix to provide useful error reporting for power management (LP: #1155175)

  [ Chris Van Hook ]
  * debian/patches/99-fix-ipmi-stat-lp1086160.patch: Fix ipmi power command
    to correctly use --stat. (LP: #1086160)

  [ Steve Langasek ]
  * Add missing dependency on iproute to maas-region-controller, for use of
    /sbin/ip in postinst.

  [ Andres Rodriguez ]
  * debian/patches/99-fix-maas-fpi.patch: Fix FPI, otherwise nodes have the
    risk of not being installed at all.
  * debian/control: Depends on apache2 for maas-cluster-controller
  * debian/maas-cluster-controller.install: Install maas-cluster-http.conf
  * debian/maas-cluster-controller.{postinst,postrm}: Handle symlink and
    removal of maas-cluster-http.conf.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 20 Mar 2013 13:08:04 -0400

maas (1.3+bzr1455+dfsg-0ubuntu1) raring; urgency=low

  * New upstream bugfix release.
    - Fixes and returns the 'resource_url' with the 'canonical' url for
      a file that is fetched using the API (LP: #1154142)

  [ Andres Rodriguez ]
  * debian/control:
    - Change Conflicts/Replaces for Breaks/Replaces.
    - Conflicts on tftpd-hpa and dnsmasq.
    - Do not pre-depends, but Depends on ${misc:Depends} for 'maas'.

  [ Steve Langasek ]
  * postinst scripts are never called with 'reconfigure' as the script
    argument.  Remove references to this (mythical) invocation.
  * always call 'set -e' from maintainer scripts instead of passing 'sh -e'
    as the interpreter, so that scripts will behave correctly when run via
    'sh -x'.
  * invoke-rc.d is never allowed to not exist - simplify scripts (and make
    them better policy-compliant) by invoking unconditionally.  (The only
    possible exception is in the postrm, where it's *theoretically* possible
    for invoke-rc.d to be missing if the user has completely stripped
    down their system; that's a fairly unreasonable corner case, but we
    might as well be correct if it ever happens.)
  * db_get+db_set is a no-op; don't call db_set to push back a value we just
    got from db_get.
  * Omit superfluous calls to 'exit 0' at the end of each script.
  * Remove maas-cluster-controller prerm script, which called debconf for no
    reason.
  * Don't invoke debconf in the postrm script either, debhelper already does
    this for us.
  * Other miscellaneous maintainer script fixes
  * debian/maas-common.postinst: call adduser and addgroup unconditionally;
    the tools are already designed to DTRT, we don't need to check for the
    user/group existence before calling them nor should we worry about
    calling them only once on first install.
  * debian/maas-common.postrm: delete the maas group, not just the user,
    as the comment in the code implies we should do.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 19 Mar 2013 15:38:22 -0400

maas (1.3+bzr1452+dfsg-0ubuntu1) raring; urgency=low

  * New upstream release.
    - MAAS file storage mechanism is shifting from a single shared
      namespace to a per-user namespace. Operators of the majority
      of MAAS systems will not notice any change. However, operators
      of the most complex installations may find that a new
      "shared-environment" user is created, and that some resources
      are reassigned to it, such as API credentials and SSH public
      keys. This provides a transitional environment that mimics the
      behaviour of a shared namespace.

  [ Raphaël Badin ]
  * debian/control: maas-region-controller depends on bind9utils.
    (LP: #1103195)
  * debian/maas-dns.postinst: Call write_dns_config.
    (LP: #1085865).
  * debian/maas-cluster-controller.postinst: Fix the name of the config
    file (/etc/maas/pserv.yaml and not /etc/maas/pserv.conf)
    (LP: #1083542).
  * debian/extras/99-maas-sudoers: Add 'SETENV:' to sudo rule
    to allow preserving the environment when running
    /usr/sbin/maas-import-pxe-files via sudo.
  * debian/maas-dns.postinst: fix permissions and group ownership of
    file /etc/bind/maas/named.conf.rndc.maas. (LP: #1066935)
  * debian/control: Remove the dependency of maas-cluster-controller
    on rabbitmq-server. (LP: #1072744)
  * debian/extras/99-maas-sudoers: Add sudo rule for script
    /usr/sbin/maas-import-pxe-files.
  * debian/maas-cluster-controller.install: Removed commissioning-user-data
    script.

  [ Julian Edwards ]
  * debian/maas-region-controller.install: Remove installation of maas-gc; it
    is no longer required as upstream no longer stores files in the filesystem.
    (LP: #1069734)
  * debian/maas-cluster-controller.postinst: Ensure that /etc/maas/pserv.yaml
    is updated when reconfiguring. (LP: #1081212)

  [ Jeroen Vermeulen ]
  * debian/maas-cluster-controller.install: Install import scripts.
  * debian/maas-cluster-controller.postinst: Configure tgt (the iSCSI server)
    so the import script can install files to it.
  * debian/maas-cluster-controller.postrm: Clean up tgt config.
  * debian/maas-region-controller.install: Move import scripts out to the
    cluster controller, and drop the maas-import-isos compatibility script.
  * debian/maas-region-controller.postinst: Remove tgt config.
  * debian/maas-region-controller.postrm: Remove tgt config cleanup.
  * Bump code revision to include latest user_data.template fixes.

  [ Gavin Panella ]
  * debian/extras/99-maas: squashfs image download is no longer needed.


=== debian/control ===
Source: maas
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 8.1.0~),
               dh-apport,
               po-debconf,
               python (>= 2.7),
               python-distribute,
               python-django
Standards-Version: 3.9.3
X-Python-Version: >= 2.7
Homepage: https://launchpad.net/maas

Package: maas
Architecture: all
Depends: ${misc:Depends}, maas-cluster-controller, maas-region-controller, python-django-maas
Description: Ubuntu MAAS Server
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package is a metapackage which installs a complete MAAS
 service on a single machine.

Package: maas-common
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Description: Ubuntu MAAS Server
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package contains common files

Package: maas-region-controller
Architecture: all
Depends: apache2,
         avahi-daemon,
         bind9utils,
         dbconfig-common,
         iproute,
         libapache2-mod-wsgi,
         libjs-raphael,
         libjs-yui3-full,
         libjs-yui3-min,
         maas-common (= ${binary:Version}),
         postgresql-9.1,
         pwgen,
         python-django,
         python-django-maas (= ${binary:Version}),
         python-django-piston,
         python-django-south,
         python-maas-provisioningserver (= ${binary:Version}),
         rabbitmq-server,
         rsyslog,
         squid-deb-proxy,
         ${misc:Depends},
         ${python:Depends}
Recommends: openssh-server
Suggests: maas-dns
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Description: Ubuntu MAAS Server
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package installs the region controller services: the web
 UI and the database.

Package: python-maas-provisioningserver
Section: python
Architecture: all
Depends: python-celery,
         python-formencode,
         python-lockfile,
         python-lxml,
         python-maas-client,
         python-netifaces,
         python-oops,
         python-oops-amqp,
         python-oops-datedir-repo,
         python-oops-twisted,
         python-pyparsing,
         python-tempita,
         python-twisted-core,
         python-twisted-web,
         python-txamqp,
         python-txtftp,
         python-yaml,
         python-zope.interface,
         ${misc:Depends},
         ${python:Depends}
Breaks: python-django-maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-cluster-controller (<= 0.1+bzr1243+dfsg-0ubuntu3)
Replaces: python-django-maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-cluster-controller (<= 0.1+bzr1243+dfsg-0ubuntu3)
Description: Ubuntu MAAS Server
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package contains the provisioning server libraries.

Package: maas-cli
Architecture: all
Depends: python-bzrlib,
         python-httplib2,
         python-maas-client (= ${binary:Version}),
         python-oauth,
         ${misc:Depends},
         ${python:Depends}
Description: Ubuntu MAAS Client Tool
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package contains the client command line tool.

Package: python-maas-client
Section: python
Architecture: all
Depends: python-oauth, ${misc:Depends}, ${python:Depends}
Breaks: maas (<= 0.1+bzr971+dfsg-0ubuntu2 )
Replaces: maas (<= 0.1+bzr971+dfsg-0ubuntu2 )
Description: Ubuntu MAAS API Client - (python files)
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package contains the client API Python modules.

Package: maas-cluster-controller
Architecture: all
Depends: apache2,
         bind9utils,
         distro-info,
         freeipmi-tools,
         maas-cli (=${binary:Version}),
         maas-common (=${binary:Version}),
         python-celery,
         python-httplib2,
         python-lockfile,
         python-maas-provisioningserver (=${binary:Version}),
         python-netaddr,
         python-oauth,
         python-tempita,
         python-twisted,
         python-zope.interface,
         rsyslog,
         syslinux-common,
         tgt,
         uuid-runtime,
         wget,
         ${misc:Depends},
         ${python:Depends}
Suggests: maas-dhcp (= ${binary:Version})
Conflicts: tftpd-hpa
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-region-controller ( <= 0.1+bzr1314+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-region-controller ( <= 0.1+bzr1314+dfsg-0ubuntu1 )
Description: Ubuntu MAAS Cluster Controller
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package contains the cluster controller, which is
 responsible for controlling remote DHCP/TFTP instances on their
 own subnets.

Package: python-django-maas
Section: python
Architecture: all
Depends: python-avahi,
         python-celery,
         python-convoy,
         python-dbus,
         python-lockfile,
         python-lxml,
         python-maas-client (= ${binary:Version}),
         python-netaddr,
         python-oops,
         python-oops-amqp,
         python-oops-datedir-repo,
         python-oops-twisted,
         python-oops-wsgi,
         python-psycopg2,
         python-sphinx,
         python-tempita,
         python-twisted,
         python-txamqp,
         python-txlongpoll,
         python-zope.interface,
         ${misc:Depends},
         ${python:Depends}
Description: Ubuntu MAAS Server - (django files)
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package contains the Django files.

Package: maas-dhcp
Architecture: all
Depends: isc-dhcp-server, ${misc:Depends}
Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Description: Ubuntu MAAS Server - DHCP Configuration (meta-package)
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package configures a DHCP that can be used with MAAS.

Package: maas-dns
Architecture: all
Depends: bind9,
 maas-region-controller (= ${binary:Version}),
 maas-dhcp (= ${binary:Version}),
 ${misc:Depends}
Conflicts: dnsmasq
Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Description: Ubuntu MAAS Server - DNS configuration (metapackage)
 Ubuntu MAAS Server is the successor to Orchestra. It offers a
 nice UI to provision your Ubuntu servers. Each physical server
 (“node”) will be commissioned automatically on first boot.
 During the commissioning process administrators are able to
 configure hardware settings manually before an automated smoke
 test and burn-in test are done. Once commissioned, a node can
 be deployed on demand by name, or allocated to a queue for
 dynamic allocation to services being deployed on this MAAS.
 .
 This package configures a DNS that can be used with MAAS.

## maas 1.4+bzr1693+dfsg

=== Makefile ===
--- 
+++ 
@@ -48,8 +48,8 @@
 # the system. This may prompt for a password.
 install-dependencies:
 	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
-		--no-install-recommends install \
-		$(shell sort -u required-packages/base required-packages/dev)
+	    --no-install-recommends install $(shell sort -u \
+	        $(addprefix required-packages/,base dev doc))
 
 bin/python bin/pip:
 	$(virtualenv) --python=$(python) --system-site-packages $(CURDIR)

=== acceptance/Makefile ===
--- 
+++ 
@@ -39,7 +39,7 @@
 
 define ephexec
 sudo LC_ALL=C SSH_ASKPASS=$(abspath ubuntupass) setsid \
-    lxc-start-ephemeral -b $(abspath .) -o $(container) -u ubuntu -- \
+    lxc-start-ephemeral -b $(upstream) -o $(container) -u ubuntu -- \
     DEBIAN_FRONTEND=noninteractive SUDO_ASKPASS=$(abspath ubuntupass)
 endef
 
@@ -48,7 +48,7 @@
 endef
 
 define check-service
-test $(2) = $(wordlist 2,2,$(shell service $(1) status))  # $(1)
+test $(2) = $(wordlist 2,2,$(shell initctl --system status $(1)))  # $(1)
 endef
 
 ## Top-level targets.
@@ -67,12 +67,16 @@
 
 container: $(containerdir)
 
+container-update: $(containerdir) | services sudo
+	$(abspath update-container) $(container)
+
 services:
 	$(call check-service,lxc,start/running)
 	$(call check-service,lxc-net,start/running)
 
 define phony-outer-targets
   container
+  container-update
   services
   test
 endef
@@ -97,7 +101,7 @@
   dh-apport
 endef
 
-build-inner: upgrade-inner
+build-inner: | upgrade-inner
 	sudo -AE apt-get --assume-yes install $(strip $(missing-packages))
 	sudo -AE apt-get --assume-yes install $(strip $(build-packages))
 	cd source && debuild -i -us -uc -b
@@ -120,9 +124,10 @@
 source/debian: | source
 	bzr export $@ $(packaging)/debian
 
-$(containerdir): | sudo
+$(containerdir): | services sudo
 	sudo lxc-create -n $(container) \
-	    -t ubuntu -- --release $(series)
+	    -f /etc/lxc/default.conf -t ubuntu -- --release $(series)
+	$(abspath update-container) $(container)
 
 ## Miscellaneous.

=== debian/changelog ===
maas (1.4+bzr1693+dfsg-0ubuntu2) saucy; urgency=low

  * debian/patches:
    - 99_fix_wsgi_app_group_lp1237463.patch: Import wsgi into the %{GLOBAL}
      application group, to avoid bson encoding issues. (LP: #1237463)
    - 99_ephemeral_backward_compat_lp1238376.patch: Maintain import_ephemerals
      config compatibility to allow maas-import-ephemerals to inherit the
      config used for maas-import-pxe-files, otherwise it will always download
      all releases even when set to a particular one. (LP: #1238376)
    - 99_split_config_arch_rel_lp1238681.patch: arches/releases are a list
      of characters that need to be split. (LP: #1238681)
    - 99_handle_ephemeral_archs_correctly.patch: Allow maas-import-ephemerals
      to use arches correctly coming from the legacy config (LP: #1240215)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 14 Oct 2013 13:10:21 -0400

maas (1.4+bzr1693+dfsg-0ubuntu1) saucy; urgency=low

  * New Upstream Release (LP: #1218526)
    - This new upstream release contains fixes and improvements of the
      features approved by the FFe above.
    - Fixes commissioning failure on Saucy with 'Failed Test' (LP: #1237364)
    - Fixes access of static images over http  (LP: #1236544)
  * d/maas-cluster-controller.postinst: a2enmod version module (LP: #1236544)
  * d/control: Bump depends on python-django to 1.4. (LP: #1236572)
  * d/maas-dhcp.postinst: Fail gracefully if apparmor_parser fails, allowing
    to install maas-dhcp during an ISO install. (LP: #1236786)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 04 Oct 2013 12:33:05 -0400

maas (1.4+bzr1656+dfsg-0ubuntu2) saucy; urgency=low

  * debian/control: Recommends on maas-dns instead of Depends for region
    because maas-dns needs the region installed first.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 03 Oct 2013 10:36:20 -0400

maas (1.4+bzr1656+dfsg-0ubuntu1) saucy; urgency=low

  [ Andres Rodriguez ]
  * New upstream bugfix release.
    - Respect filters for ephemerals_script.py.
  * debian/control: Depends on ubuntu-cloudimage-keyring instead of
    ubuntu-cloud-keyring; depends on python-distro-info.
  * debian/control: Remove suggests on maas-dhcp and maas-dns as they are
    now dependencies.

  [ Scott Moser ]
  * debian/control: Bump depends on isc-dhcp-server to 4.2.4
  * debian/maas-dhcp.maas-dhcp-server.upstart: Change ownership of leases
    file to root:root, and run the daemon as dhcpd:dhcpd.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 01 Oct 2013 15:26:34 -0400

maas (1.4+bzr1655+dfsg-0ubuntu1) saucy; urgency=low

  * New Upstream release. (LP: #1218526)
  * debian/control:
    - Depends on python-djorm-ext-pgarray, python-curtin,
      python-simplestreams, ubuntu-cloud-keyring.
    - Depends on maas-dns, maas-dhcp to get them seeded and
      into main (LP: #1227353)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 28 Aug 2013 11:17:44 -0400

maas (1.4+bzr1551+dfsg-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 15 Aug 2013 16:20:41 -0400

maas (1.4+bzr1548+dfsg-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 18 Jul 2013 10:15:10 -0400

maas (1.4+bzr1539+dfsg-0ubuntu1) saucy; urgency=low

  * New upstream release
  * Symlink apache2 config into /etc/apache2/conf-enabled/ instead of
    /etc/apache2/conf.d as apache2.4 no longer supports the latter.
    - debian/maas-cluster-controller.{postinst,postrm}
    - debian/maas-region-controller.{postinst,postrm}
  * debian/control: Bump Standards-Version to 3.9.4.
  * debian/maas-cluster-controller.lintian-overrides: Remove unneeded
    override and add a new one.
  * debian/maas-region-controller.lintian-overrides: Add extra overrides.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 03 Jul 2013 17:11:02 -0400

maas (1.4+bzr1538+dfsg-0ubuntu1) saucy; urgency=low

  * New upstream release
  * debian/patches/04-setup-dont-user-list-snippets.patch: Drop. Merged
    Upstream.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 13 Jun 2013 20:06:35 -0400

maas (1.4+bzr1527+dfsg-0ubuntu1) saucy; urgency=low

  * debian/patches/04-setup-dont-user-list-snippets.patch: Drop importing
    maasserver modules to list snippets in favor to using glob. Otherwise
    we would have to add various non necessary Build-Dependencies.

  [ Jeroen Vermeulen ]
  * Install templates into /etc/maas/templates/.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 03 Jun 2013 17:59:31 -0400

maas (1.4+bzr1505+dfsg-0ubuntu1) saucy; urgency=low

  * New upstream release

  [ Steve Langasek ]
  * Add missing dependency on iproute to maas-region-controller, for use of
    /sbin/ip in postinst.

  [ Julian Edwards ]
  * debian/maas-dhcp.maas-dhcp-server.upstart:
    - Detect 12.04 as the host OS and install with correct permissions. This
      allows the same packaging to be used in the 12.04 backport.

  [ Andres Rodriguez ]
  * Update packaging to support FPI:
    - debian/control: Depends on apache2 for maas-cluster-controller.
    - debian/maas-cluster-controller.install: Install http config file.
    - debian/maas-cluster-controller.{postinst,postrm}: Handle symlink creation
      and deletion.
  * debian/maas-region-controller.install: Install preseeds in
    etc/maas/preseeds. (LP: #1073463)

  [ Jeroen Vermeulen ]
  * In the source tree, /etc/maas/pserv.yaml has moved from etc/ to etc/maas/.
  * Install templates into /etc/maas/templates/.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 03 Jun 2013 16:53:14 -0400

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                python (>= 2.7),
                python-distribute,
                python-django
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 X-Python-Version: >= 2.7
 Homepage: https://launchpad.net/maas
 
@@ -59,18 +59,18 @@
          maas-common (= ${binary:Version}),
          postgresql-9.1,
          pwgen,
-         python-django,
+         python-django (>= 1.4),
          python-django-maas (= ${binary:Version}),
          python-django-piston,
          python-django-south,
          python-maas-provisioningserver (= ${binary:Version}),
+         python-djorm-ext-pgarray,
          rabbitmq-server,
          rsyslog,
          squid-deb-proxy,
          ${misc:Depends},
          ${python:Depends}
-Recommends: openssh-server
-Suggests: maas-dns
+Recommends: openssh-server, maas-dns (= ${binary:Version})
 Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
 Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
 Description: Ubuntu MAAS Server
@@ -90,6 +90,7 @@
 Section: python
 Architecture: all
 Depends: python-celery,
+         python-distro-info,
          python-formencode,
          python-lockfile,
          python-lxml,
@@ -100,6 +101,7 @@
          python-oops-datedir-repo,
          python-oops-twisted,
          python-pyparsing,
+         python-simplestreams,
          python-tempita,
          python-twisted-core,
          python-twisted-web,
@@ -169,6 +171,7 @@
          freeipmi-tools,
          maas-cli (=${binary:Version}),
          maas-common (=${binary:Version}),
+         maas-dhcp (=${binary:Version}),
          python-celery,
          python-httplib2,
          python-lockfile,
@@ -181,11 +184,11 @@
          rsyslog,
          syslinux-common,
          tgt,
+         ubuntu-cloudimage-keyring,
          uuid-runtime,
          wget,
          ${misc:Depends},
          ${python:Depends}
-Suggests: maas-dhcp (= ${binary:Version})
 Conflicts: tftpd-hpa
 Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-region-controller ( <= 0.1+bzr1314+dfsg-0ubuntu1 )
 Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-region-controller ( <= 0.1+bzr1314+dfsg-0ubuntu1 )
@@ -209,6 +212,7 @@
 Depends: python-avahi,
          python-celery,
          python-convoy,
+         python-curtin,
          python-dbus,
          python-lockfile,
          python-lxml,
@@ -242,7 +246,7 @@
 
 Package: maas-dhcp
 Architecture: all
-Depends: isc-dhcp-server, ${misc:Depends}
+Depends: isc-dhcp-server (>= 4.2.4), ${misc:Depends}
 Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
 Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
 Description: Ubuntu MAAS Server - DHCP Configuration (meta-package)

=== debian/rules ===
#!/usr/bin/make -f

BUILDHOME = $(CURDIR)/debian/build
PYTHON = $(shell pyversions -d)
# Python enum modules.
py_enums := $(wildcard src/*/enum.py)

%:
	dh $@ --with python2,apport --buildsystem=python_distutils

override_dh_installinit:
	dh_installinit --name maas-pserv
	dh_installinit --name maas-txlongpoll
	dh_installinit --name maas-region-celery
	dh_installinit --name maas-cluster-celery
	dh_installinit --name maas-dhcp-server

override_dh_auto_build:
	dh_auto_build

	mkdir -p $(BUILDHOME)
	HOME=$(BUILDHOME) PYTHONPATH=$(CURDIR)/src/ $(PYTHON)	\
		$(CURDIR)/src/maasserver/utils/jsenums.py	\
		$(py_enums) > $(BUILDHOME)/enums.js

override_dh_auto_install:
	dh_auto_install

	# Move static files
	install -d -m 755  $(CURDIR)/debian/tmp/usr/share/maas/web/static
	mv $(CURDIR)/debian/tmp/usr/lib/python*/*-packages/maasserver/static \
                $(CURDIR)/debian/tmp/usr/share/maas/web/

	# Install built enums.js file.
	cp $(BUILDHOME)/enums.js $(CURDIR)/debian/tmp/usr/share/maas/web/static/js/

	# install the apparmor profile
	install -d -m 755 $(CURDIR)/debian/tmp/etc/apparmor.d/dhcpd.d
	install -m 644 $(CURDIR)/debian/maas-dhcp.apparmor \
	    $(CURDIR)/debian/tmp/etc/apparmor.d/dhcpd.d/maas

	dh_install --list-missing

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDHOME)
	rm -rf src/*.egg-info

DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
REV=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: .*[+~]bzr([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
get-orig-source:
	bzr export -r $(REV) --root=maas-$(VER).orig \
             maas_$(VER).orig.tar.gz lp:maas
	rm -rf maas-$(VER)
	tar -xf maas_$(VER).orig.tar.gz
	rm maas_$(VER).orig.tar.gz
	rm -rf maas-$(VER).orig/src/maasserver/static/jslibs/
	rm -rf maas-$(VER).orig/contrib/python-tx-tftp
	GZIP=--best tar -cz --owner root --group root --mode a+rX \
                        -f maas_$(VER).orig.tar.gz \
                        maas-$(VER).orig
	rm -r maas-$(VER).orig
